/**********************************************************************
 *
 * gsdltools.cpp -- 
 * A component of the Greenstone digital library software
 * from the New Zealand Digital Library Project at the
 * University of Waikato, New Zealand.
 *
 * Copyright (C) 1999  The New Zealand Digital Library Project
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: gsdltools.cpp 1146 2000-05-04 05:16:23Z sjboddie $
 *
 *********************************************************************/

/*
   $Log$
   Revision 1.4  2000/05/04 05:16:23  sjboddie
   Moved dm_safe from htmlutils to gsdltools. Also made it escape '\'
   characters to prevent their mysterious disapearance from things like
   windows filenames when they get passed through the macro expander.

   Revision 1.3  2000/04/06 19:58:01  cs025
   Correcting a correction - reinstated all lib files due to silly
   CVS confusion.

   Revision 1.1  2000/02/29 01:37:00  sjboddie
   tidied up endianness

 */


#include "gsdltools.h"

bool littleEndian() {
  char s[2] = {'\xFE', '\xEF'};

  if (sizeof(unsigned short) == 2)
    return *(unsigned short*)s == 0xEFFE;
  else if (sizeof(unsigned int) == 2)
    return *(unsigned int*)s == 0xEFFE;
}

text_t dm_safe (const text_t &instring) {

  text_t outstring;
  text_t::const_iterator here = instring.begin();
  text_t::const_iterator end = instring.end();
  while (here != end) {
    if (*here == '_' || *here == '\\') outstring.push_back('\\');
    outstring.push_back(*here);
    here ++;
  }
  return outstring;
}

